![Logo](images/logo.png "Крестьянство SDK")

**Крестьянство SDK** представляет собой приложение, написанное на языке SmallTalk для 3-х мерной операционной системы Open Qwaq/Open Croquet, и запускается посредством виртуальной машины. Несколько запущенных приложений образуют сеть аналогичную torrent (p2p) и обеспечивают распределенные вычисления в едином пространстве на основе репликации.

[О проекте в слайдах](/about)

[Приоритетные направления разработки программы «Крестьянство»](directions/INDEX.md)

![SDK](images/sdk1.jpg "Крестьянство SDK v.1.0")


Название **«Крестьянство»** не связано непосредственно с тружениками села, но призывает исповедовать идеалы благородного коллективного труда и природосообразного познания.

Проект **«Крестьянство»** ([http://www.krestianstvo.ru](http://www.krestianstvo.ru)) ставит перед собой задачу создания новой операционной системы, нового интернет, нового интерфейса взаимодействия человека и компьютера в открытых технологиях.

**«Крестьянство» SDK** представляет собой комплекс открытого программного обеспечения, созданного для архитектуры распределенных вычислений в сети. Основным принципом разработки программного обеспечения «Крестьянство» SDK, является соответствие современному уровню развития компьютерной инженерии, математики, физики, приоритетным направлениям фундаментальной науки и искусства, но не маркетинговым исследованиям и бизнес-логике.

Используя существующие общедоступные транспортные каналы связи, «Крестьянство» SDK позволяет организовывать на них в неограниченном количестве общественные, гетерогенные, защищенные, одноранговые сети типа точка-точка (p2p, торент) на основе распределенных вычислений и репликации, самостоятельно без помощи системных администраторов и программистов.

«Крестьянство» SDK позволяет любому желающему создать виртуальное обучающее пространство для многопользовательского защищенного взаимодействия, которое обеспечит синхронную работу над объектами определенной доменной области в реальном времени. Несколько запущенных приложений на основе «Крестьянство» SDK образуют одноранговую сеть (p2p) и обеспечивают распределенные вычисления в едином, защищенном виртуальном пространстве.

Приложения, входящие в состав «Крестьянство» SDK представляют адекватные, конформные по форме и содержанию методы взаимодействия человека с информационными технологиями с использованием средств виртуальной, дополненной реальности, средств навигации и робототехники.

Программный комплекс позволяет любому желающему создавать мобильные системы автоматической виртуальной реальности CAVE (Cave Automatic Virtual Environment), а так же системы дополненной реальности для взаимодействия с компьютером. Количество создаваемых секторов CAVE, участвующих в проекции не ограничено.

Приложения, входящие в состав SDK, разрабатываются на языках программирования высокого уровня Smalltalk, JavaScript, Ruby, Python и запускаются посредством виртуальных машин, не требующих инсталляции. В основе «Крестьянство» SDK лежат передовые открытые разработки в области распределенных вычислений: 3-х мерная операционная система OpenQwaq/OpenCroquet на языке Smalltalk/Python; инструментарий создания виртуальных миров в интернет Virtual World Framework на языке JavaScript/Ruby; инструментарий живого программирования в интернет LivelyKernel на языке JavaScript/Smalltalk.

Программирование осуществляется как на английском так и на русском языках, в пределе с полным отказом от английского. Так, русские символы могут использоваться как в низкоуровневых, так и высокоуровневых именах методов языка Smalltalk/JavaScript.

На сервере [http://www.krestianstvo.ru](http://www.krestianstvo.ru) создан постояннодействующий сервис виртуальных миров, позволяющий организовать совместную работу пользователей через сеть интернет, как посредством запуска приложения «Крестьянство» SDK для операционной системы Windows, Mac OS X, Linux, так и напрямую через интернет-браузер Google Chrome, Mozilla FireFox, Apple Safari.
