#Методология

![Logo](../images/logo.png "Крестьянство SDK")


"Название Крестьянство не связано непосредственно с тружениками села, но призывает исповедовать идеалы благородного коллективного труда и природосообразного познания."




«КРЕСТЬЯНСТВО», «ИГРИЩЕ», «ОБРЯД»
моделирование среды бескорыстного творчества



Осознание таких терминов как «виртуальная реальность», «расширенная реальность», «живой код» предполагает коренной пересмотр мировоззрения современного человека. И, находясь на пороге биотехнологий, нанотехнологий, молекулярных и квантовых компьютеров, идеи, заложенные в архитектуру ЭВМ и теории информации в прошлом веке, уже больше не могут удовлетворять запросам современной науки и искусства.

В чем же заключается новый взгляд?

Чересчур широкое и расплывчатое понятие информации и способов ее передачи, долгие годы и до сих пор вводило многих людей и ученых в заблуждение. Что естественным образом порождало множество лжетеорий, объясняющих “научно”: передачу мыслей на расстоянии, “аномальные” явления природы и т.д.
Связано это с тем, что в обыденном сознании человека, в том числе и под серьезным влиянием фон-Неймановской архитектуры современного компьютера, сложилось твердое представление, о том, что: человек на протяжении всей своей жизни работает с данными или информацией. Полученные данные он может обрабатывать, передавать, накапливать в памяти, извлекать из памяти, анализировать и т.д., подобно “менеджеру по работе с данными”, накопленными лично им или человечеством до него, что неважно. Эти данные он сохраняет в книгах, произведениях визуального и музыкального искусства, народном творчестве, архитектуре, сейчас у него есть возможность сохранять и на современных носителях информации, или просто оставлять в идеях. Человек действует по принципам “коллекционера-индивидуалиста антикварной лавки”, где каждая вещь – изначально по определению стара или мертва, то есть “бездействует, ради собственного сохранения”, но имеет стоимость, которая возрастает с течением времени и, в конце концов, делает ее “бесценной”. Соответственно ему требуется “серьезно охранять свое богатство” используя: законы по защите интеллектуальной собственности, средства защиты информации, предотвращать “акты вандализма”. Что касается компьютерной информации, то это: беспредельное создание копий, постоянная борьба с вирусами и хакерами и т.д. Причем в качестве цензоров выступают люди абсолютно не имеющие отношения к рецензируемому материалу, это – менеджеры, продюсеры, системные администраторы и т.д., люди, не сведущие в современном научно-техническом и духовном производстве, по большому счету являющиеся продавцами. Именно они решают, кто есть “хакер” или что вредно - что полезно, и устанавливают единые законы защиты, не давая ни малейшей возможности, проявится созидательной творческой личности. В данном случае, под “хакером” мы подразумеваем “человека, смотрящего в корень” исходя из первородного значения слова. Программист не может выпустить в свет ни один программный продукт “не убив его”, иначе он не гарантирует сохранность информации, с которой будет работать пользователь.
И время показывает, что созданная в сознании человека система ценностей и понятий фон-Неймановского компьютера идеально соответствует бизнес-ориентированной архитектуре общества.

Но человек рожден не только для того чтобы “иметь”, но в первую очередь –“быть”, а именно - творцом окружающего его мира.
И, как говорят: природу нельзя обмануть.

С бурным развитием сетевых и открытых технологий, стало просто невозможным более держать оборону по защите “антикварных лавок”, идеи типа “ноу-хау” - больше не представляли интереса, так как новые методы компьютерного моделирования позволили с легкостью генерировать любой тип данных в реальном времени, тем самым пропала необходимость постоянно их хранить в памяти.
В компьютерных технологиях наступает век генеративного или биологического программирования и искусства. Основными понятиями являются: «открытость», «репликация», «самопорождение». Технология движется по пути к полному отказу от таких терминов как «информация», «данные», теория передачи информации, «память» в любых формах ее представления и соответственно операций «сохранить», «извлечь», «удалить», защита информации и т.д. Так как новые понятия «репликация» и «самопорождение» призывают мыслить в терминах «реального времени», где всякий порождаемый объект генерируется заново, в каждый новый момент времени своей жизни.
Его невозможно сохранить или удалить, и если вам удалось это сделать, то – это критерий «мертвого кода». Свойство «сомопорождения объекта» невозможно без свойства «открытости» системы в целом». «Открытость» кода гарантирует запущенной программе возможность самоизменения и модификации во время своего исполнения. Что соответствует философии генеративного программирования, по аналогии с живым организмом в биологии. Тогда, такая программа может быть настроена на неограниченное количество сенсоров, снимающих показатели окружающей среды, и в ходе работы адаптироваться к ней, тем самым гармонично отвечая запросам человека. Только возможность непредопределенной самогенерации позволяет моделирующемуся в реальном времени «виртуальному миру» адекватно совмещается с реальностью, окружающей человека. Где человек в итоге уже будет взаимодействать не с компьютером/роботом, а с окружающей его «расширенной реальностью», частью которой является и он сам.
Так, главной частью программы будет являться сам человек с его внутренним и внешним реальным миром. Все копии одной и той же программы будут кардинально отличаться друг от друга, тем самым отпадет надобность в защите интеллектуальной собственности.
«Репликация» позволяет в каждом узле сети генерировать один в один модели всех остальных узлов, участвующих в соединении. Это в чем-то напоминает устройство голограммы.
«Хакеров» и «вирусов» не станет. Так как, «хакерами» – будут все пользователи, а программы на основе «самогенерации» и будут основаны на вирусах. «Вирус» станет критерием «живого кода». Программы будут формировать во времени собственную иммунную систему и в случае необходимости генерировать биллионы антител, готовых защитить себя от внешнего и внутреннего агрессора. Вирусы будут составлять основу для антител, в последующем их будут называть ретровирусами.
Сейчас все привыкли к тому, что в компьютере существует программа, в виде листинга или откомпилированная, которая может быть запущена на виртуальной машине ее языка программирования. Причем виртуальная машина языка так же заранее откомпилирована и представляет собой «мертвый код», который всегда однозначно выдает один и тот же результат вычислений. Виртуальная машина «живого кода» не будет ни когда откомпилирована, и сможет в процессе выполнения программы менять собственный язык программирования, что сделает ее полностью неуязвимой от природоразрушающих агрессивных воздействий, и будет гарантировать сохранение главного свойства «открытости». Операционных систем и виртуальных машин будет ровно столько – сколько компьютерных программ и их копий, и ни одной повторяющейся версии.
На сегодня известна разработка единственной в мире такой операционной системы, размер которой будет составлять 20 килобайт (что составляет примерно 1/70 часть гибкой дискеты 1.4”) для новой архитектуры материнских плат компьютеров.
Следуя вышеизложенным принципам, ведется разработка нового программного обеспечения «КРЕСТЬЯНСТВО», «ИГРИЩЕ», «ОБРЯД» (автор Суслов Н.В.). Разработка осуществляется при поддержке Российского Фонда Фундаментальных Исследований в рамках проекта (№ 07-07-00332-а). На них базируются последние мультимедиа-издания Третьяковской галереи и мультимедиа инсталляция «Фрески А.Иванова». Программы написаны на языке SmallTalk, запускаются без инсталляции, с полностью открытым кодом.

«КРЕСТЬЯНСТВО» - «название не связано непосредственно с тружениками села, но призывает исповедовать идеалы благородного коллективного труда и природосообразного познания. В инсталляции обеспечивает распределенные вычисления в сети».

«ИГРИЩЕ» - «наша задача перевести потребительский взгляд в режим бескорыстного творчества». В инсталляции обеспечивает взаимодействие посетителя с расширенной реальностью, в том числе и своего внутреннего мира.

«ОБРЯД» - обеспечивает математические вычисления особого типа.

«Фрески А.Иванова» - это пример проекта «расширенной реальности», где сеть из компьютеров моделирует помещение с фресками художника в музейном зале. Четыре компьютера, соединенных в сеть смогли превратить пространство одного из залов в исследовательскую лабораторию творчества художника. Реальность расширяется за счет полного совмещения смоделированного виртуального мира с реальным пространством, световых потоков, акустики и геометрии стен. Сенсорная панель обеспечивает пульт управления пространством. Посетитель, находящийся в центре зала перед ней, может с помощью панели: управлять виртуальным освещением; менять конфигурации размещения изображений на стенах; изменять геометрию помещения, например путем добавления виртуальных углов, окон. отражающиеся и на звуковом сопровождении (акустика виртуального помещения); повторять наиболее удавшиеся состояния, и просматривать, созданные искусствоведами. Пульт управления может быть не один и находится не обязательно в экспозиции, что позволит управлять действом удаленно и сразу нескольким людьми одновременно. Самих же активных стен может быть так же неограниченное число, что позволит превратить в единый живой организм всю галерею целиком (здание), включая фасады с внешней стороны улицы. Приходящий человек становится основным звеном вычислений медиа-здания галереи. И для него главным становится не сам факт наличия того или иного произведения, а та формула художника, которую он сможет применить к окружающему себя миру в реальной жизни.

Новые технологии сами собой предвещают рождение человека и общества нового типа, самовозникшего на принципах открытости, бескорыстности, коллективного благородного труда и творчества.



Примечания:
В 2006 г., на основе среды «Крестьянство» создан диск (2D версия) “Уистлер и Россия” и издан в Государственной Третьяковской галерее.
В настоящее время ведется разработка 3D версии с поддержкой совместной работы пользователей по сети в 3-х мерном пространстве, где каждый элемент содержания будет доступен для совместного обозрения и взаимодействия.
В 2006 г., на основе среды «Крестьянство», «Игрище» создана мультимедиа инсталляция “А.Иванов. Библейский эскизы” в Государственной Третьяковской галерее. Это проект расширенной реальности, где сеть из трех компьютеров моделирует помещение с фресками художника музейном зале. Победитель конкурса «Меняющийся музей в меняющемся мире» 2007 г. Благотворительного фонда В.Потанина.
В настоящее время ведутся эксперименты по увеличению числа проекций - более 6 стен (включая пол и потолок), выступающих как единое реальное пространство, совмещенное с проецируемым на него виртуальным; разработка сенсорного пульта управления, позволяющего самим зрителям управлять инсталляцией в реальном времени.
В 2007 г. на основе среды «Крестьянство» создан диск “A.A.Иванов. Рисунок. Акварель. Библейские эскизы”.
Диск позволяет работать с содержанием как одному, так и неограниченному числу пользователей одновременно посредством локальной сети или Интернет; создавать аннотации к произведениям, новые альбомы и сохранять их непосредственно в структуре диска; встроенная поддержка полнотекстового поиска. Диск не требует инсталляции, запускается с СD-Rom или переносного носителя и работает по аналогии с Веб сервером/ базой данных.


Технические характеристики программных реализаций:
Тип ЭВМ: PС x86 32bit, Mac-Intel
Язык: SmallTalk
ОС: Linux OS, Windows Vista/7, MacOS X 10.x.
Объём программы: ~100 Мб
Лицензия программ: Открытая (Open Source),

Суслов Николай 2007
